package net.geant.nmaas.portal.api.bulk;

import com.opencsv.bean.CsvBindByName;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import net.geant.nmaas.portal.service.impl.BulkCsvProcessorImpl;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class CsvDomain implements BulkCsvProcessorImpl.CsvBean {

    @CsvBindByName(column = "domain")
    private String domainName;

    @CsvBindByName(column = "username")
    private String adminUserName;

    @CsvBindByName(column = "email")
    private String email;

    @CsvBindByName(column = "networks")
    private Object dcnetworks;

    @CsvBindByName(column = "domainGroups")
    private String domainGroups;

    @CsvBindByName(column = "ssoEnabled")
    private Boolean ssoEnabled;

    @Override
    public String toString() {
        return String.format("Bulk deployment for domain %s with admin %s %s. Networks: %s, DomainGroups: %s", domainName, email, adminUserName, dcnetworks, domainGroups);
    }

}
