package net.geant.nmaas.portal.persistent.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import net.geant.nmaas.portal.api.bulk.BulkType;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;
import java.time.OffsetDateTime;
import java.util.ArrayList;
import java.util.List;

@Entity
@AllArgsConstructor
@NoArgsConstructor
@Setter
@Getter
@ToString
public class BulkDeployment {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "creator_id")
    private User creator;

    private OffsetDateTime creationDate;

    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private BulkDeploymentState state;

    @Column(name = "bulk_type", nullable = false)
    @Enumerated(EnumType.STRING)
    private BulkType type;

    @OneToMany(cascade = CascadeType.ALL)
    private List<BulkDeploymentEntry> entries = new ArrayList<>();

    private Integer parallelDeploymentsLimit;

    private Boolean deleted;

    private OffsetDateTime completionDate;

}
