alter table app_deployment_spec alter column exposes_webui set default true;
alter table comment rename column application_application_id to application_id;
alter table application_subscription rename column application_application_id to application_id;
alter table application add column creation_date timestamp not null default now();

create table application_base_tag (
    application_base_id bigint not null,
    tag_id bigint not null,
    primary key (application_base_id, tag_id)
);

create table application_base (
    id bigint generated by default as identity,
    issues_url varchar(255),
    license varchar(255),
    license_url varchar(255),
    name varchar(255),
    source_url varchar(255),
    www_url varchar(255),
    logo_id bigint,
    primary key (id)
);

create table application_base_descriptions (
    application_base_id bigint not null,
    descriptions_id bigint not null
);

create table application_base_screenshots (
    application_base_id bigint not null,
    screenshots_id bigint not null
);

create table application_base_versions (
    application_base_id bigint not null,
    versions_id bigint not null
);

create table application_version (
    id bigint generated by default as identity,
    app_version_id bigint not null,
    state varchar(255) not null,
    version varchar(255) not null,
    primary key (id)
);

insert into application_version (app_version_id, state, version) select application_id, state, version from application;
insert into application_base_versions (application_base_id, versions_id) select app_version_id, id from application_version;
insert into application_base (id, issues_url, license, license_url, name, source_url, www_url, logo_id) select application_id, issues_url, license, license_url, name, source_url, www_url, logo_id from application;
alter table application drop column license;
alter table application drop column license_url;
alter table application drop column issues_url;
alter table application drop column source_url;
alter table application drop column www_url;
alter table application drop column logo_id;

insert into application_base_tag (application_base_id, tag_id) select * from application_tag;
drop table application_tag;
insert into application_base_descriptions(application_base_id, descriptions_id) select * from application_descriptions;
drop table application_descriptions;
insert into application_base_screenshots(application_base_id, screenshots_id) select * from application_screenshots;
drop table application_screenshots;

alter table application_base drop constraint if exists UK_ie1rr7i5f4h9fickct1ddmgif;
alter table application_base add constraint UK_ie1rr7i5f4h9fickct1ddmgif unique (name);
alter table application_base_descriptions drop constraint if exists UK_rf479b9it3plt2alopcs48oy1;
alter table application_base_descriptions add constraint UK_rf479b9it3plt2alopcs48oy1 unique (descriptions_id);
alter table application_base_screenshots drop constraint if exists UK_4dlhf0kvo4qm0yxkhp3uypq8y;
alter table application_base_screenshots add constraint UK_4dlhf0kvo4qm0yxkhp3uypq8y unique (screenshots_id);
alter table application_base_versions drop constraint if exists UK_lpakyu1x7s5ukgkvbkyrfxpbw;
alter table application_base_versions add constraint UK_lpakyu1x7s5ukgkvbkyrfxpbw unique (versions_id);

alter table application_base_tag add constraint FKjcn3fes2a2sd2ldsyorvyvmud foreign key (tag_id) references tag;
alter table application_base_tag add constraint FK9i6a1keviu2600uod2nko2jnt foreign key (application_base_id) references application_base;
alter table application_base add constraint FK7fhsitupl337slql2ajjq7lk6 foreign key (logo_id) references file_info;
alter table application_base_descriptions add constraint FK1rpmuduyivwwpgocyidy90ke foreign key (descriptions_id) references app_description;
alter table application_base_descriptions add constraint FK4j8pi3p1tup7uuekhk3caa3rr foreign key (application_base_id) references application_base;
alter table application_base_screenshots add constraint FKdn6cqpor1g9qsfcs4q31e0i26 foreign key (screenshots_id) references file_info;
alter table application_base_screenshots add constraint FK47oo2gel2am5rb7gteahqquy4 foreign key (application_base_id) references application_base;
alter table application_base_versions add constraint FKg1skowbclv6id34rdcsffbp5r foreign key (versions_id) references application_version;
alter table application_base_versions add constraint FKqetk98q77hml9tenqtyygtra3 foreign key (application_base_id) references application_base;
alter table comment drop constraint if exists FKl1ijg86at535f02qrnag2884f;
alter table comment add constraint FKemn5p9e8r6aeywsuvfyx18v8p foreign key (application_id) references application_base;
alter table application_subscription drop constraint if exists application_subscription_pkey;
alter table application_subscription drop constraint if exists FKNP15LBUG6JTXWYL46QTKAMBD4;
drop index if exists PRIMARY_KEY_3;
alter table application_subscription add primary key (domain_id, application_id);
alter table application_subscription add constraint FK68lfog47c3c2nel7cfahifsth foreign key (application_id) references application_base;
