create table bulk_deployment (
   id bigint generated by default as identity,
   creation_date timestamp,
   creator_id bigint,
   state integer,
   type integer,
   primary key (id)
);

create table bulk_deployment_entries (
   bulk_deployment_id bigint not null,
   entries_id bigint not null
);

create table bulk_deployment_entry (
   id bigint generated by default as identity,
   created boolean,
   successful boolean,
   type integer,
   primary key (id)
);

create table bulk_deployment_entry_details (
   bulk_deployment_entry_id bigint not null,
   details varchar(255),
   details_key varchar(255) not null,
   primary key (bulk_deployment_entry_id, details_key)
);

alter table bulk_deployment_entries
   add constraint UK_ado6d4x4magsovhwom7a56vwc unique (entries_id);

alter table bulk_deployment_entries
   add constraint FKs43yijfxr2qg97e6wewtr5oyv
   foreign key (entries_id)
   references bulk_deployment_entry;

alter table bulk_deployment_entries
   add constraint FKrpa5ypksoip46xf3pjnpnyjc
   foreign key (bulk_deployment_id)
   references bulk_deployment;

alter table bulk_deployment_entry_details
   add constraint FKnael2ore3ynmsjj0i4jmux79c
   foreign key (bulk_deployment_entry_id)
   references bulk_deployment_entry;