create table k_cluster (
        id bigint generated by default as identity,
        creation_date timestamp(6) with time zone not null,
        deployment_id bigint unique,
        ingress_id bigint unique,
        modification_date timestamp(6) with time zone not null,
        cluster_config_file varchar(4000) not null,
        codename varchar(255) not null,
        description varchar(255) not null,
        name varchar(255) not null,
        path_config_file varchar(255) not null,
        primary key (id)
    );

create table k_cluster_deployment (
        id bigint generated by default as identity,
        force_dedicated_workers boolean,
        namespace_config_option varchar(255),
        smtp_server_port integer,
        default_namespace varchar(255),
        default_storage_class varchar(255),
        smtp_from_default_domain varchar(255),
        smtp_server_hostname varchar(255),
        smtp_server_password varchar(255),
        smtp_server_username varchar(255),
        primary key (id)
    );

create table k_cluster_ingress (
        id bigint generated by default as identity,
        certificate_config_option varchar(255),
        controller_config_option varchar(255),
        ingress_per_domain boolean,
        resource_config_option varchar(255),
        tls_supported boolean,
        controller_chart_archive varchar(255),
        controller_chart_name varchar(255),
        external_service_domain varchar(255),
        issuer_or_wildcard_name varchar(255),
        public_ingress_class varchar(255),
        public_service_domain varchar(255),
        supported_ingress_class varchar(255),
        primary key (id)
    );

create table k_clusters_domains (
        k_cluster_id bigint not null,
        domain_id bigint not null
);

alter table if exists k_cluster
       add constraint FKkw3lst58qvj1fmots9sjrl31o
       foreign key (deployment_id)
       references k_cluster_deployment;

 alter table if exists k_cluster
       add constraint FKa4x6r57mr7vk69fn8xlqchonb
       foreign key (ingress_id)
       references k_cluster_ingress;

alter table if exists k_clusters_domains
       add constraint FKndxrsyl952klcberdqvvd5484
       foreign key (domain_id)
       references domain;

alter table if exists k_clusters_domains
       add constraint FKch3yhxvbwsutlu14hcw2vah3k
       foreign key (k_cluster_id)
       references k_cluster;